from collections import deque, defaultdict


def guard(n, m, k, road, guards):
    graph = defaultdict(list)
    for a, b in road:
        graph[a].append(b)
        graph[b].append(a)

    guarded = set()

    for pi, hi in guards:
        queue = deque([(pi, 0)])
        visited = set([pi])
        while queue:
            curr, dist = queue.popleft()
            if dist > hi:
                continue
            guarded.add(curr)
            for neighbor in graph[curr]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append((neighbor, dist + 1))

    guarded = sorted(guarded)
    print(len(guarded))
    if guarded:
        print(' '.join(map(str, guarded)))


n, m, k = map(int, input().split())

road = []
for _ in range(m):
    a, b = map(int, input().split())
    road.append((a, b))

guards = []
for _ in range(k):
    pi, hi = map(int, input().split())
    guards.append((pi, hi))

guard(n, m, k, road, guards)