from collections import deque, defaultdict


def guard(n, m, k, road, guards):
    graph = defaultdict(list)
    for a, b in road:
        graph[a].append(b)
        graph[b].append(a)

    guarded = set()

    for pi, hi in guards:
        if hi == 0:
            guarded.add(pi)
            continue
        queue = deque([(pi, 0)])
        visited = {pi}
        while queue:
            curr, dist = queue.popleft()
            if dist > hi:
                continue
            guarded.add(curr)
            for neighbor in graph[curr]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append((neighbor, dist + 1))

    guarded_list = sorted(guarded)
    print(len(guarded_list))
    if guarded_list:
        print(' '.join(map(str, guarded_list)))


n, m, k = map(int, input().split())
road = [tuple(map(int, input().split())) for _ in range(m)]
guards = [tuple(map(int, input().split())) for _ in range(k)]

guard(n, m, k, road, guards)