from collections import deque, defaultdict


def read_input():
    n, m, k = map(int, input().strip().split())

    roads = [tuple(map(int, input().strip().split())) for _ in range(m)]

    guards = [tuple(map(int, input().strip().split())) for _ in range(k)]

    return n, m, k, roads, guards


def find_guarded_warehouses(n, m, k, roads, guards):
    graph = defaultdict(list)
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)

    guarded = set()

    for pi, hi in guards:
        visited = set()
        queue = deque([(pi, 0)])

        while queue:
            current, distance = queue.popleft()
            if distance > hi:
                continue
            if current not in visited:
                visited.add(current)
                guarded.add(current)
                for neighbor in graph[current]:
                    if neighbor not in visited:
                        queue.append((neighbor, distance + 1))


    guarded_warehouses = sorted(list(guarded))
    print(len(guarded_warehouses))
    if len(guarded_warehouses) > 0:
        print(" ".join(map(str, guarded_warehouses)))


def main():
    n, m, k, roads, guards = read_input()
    find_guarded_warehouses(n, m, k, roads, guards)


if __name__ == "__main__":
    main()