import itertools
import math


def calculate_distance(p1, p2):
    return math.sqrt((p1[0] - p2[0]) ** 2 + (p1[1] - p2[1]) ** 2)


def min_path_with_orthogonal_constraints(coords):
    n = len(coords)
    min_path_length = float('inf')

    for order in itertools.permutations(coords):
        current_length = 0
        for i in range(1, n):
            dx = abs(order[i][0] - order[i - 1][0])
            dy = abs(order[i][1] - order[i - 1][1])
            current_length += math.sqrt(dx ** 2 + dy ** 2)  # Pythagorean theorem in ideal case

        if current_length < min_path_length:
            min_path_length = current_length

    return min_path_length


n = int(input())
coords = [tuple(map(int, input().split())) for _ in range(n)]

min_length = min_path_with_orthogonal_constraints(coords)
print(f"{min_length:.12f}")