import itertools
import math


def calculate_distance(point1, point2):
    return math.sqrt((point1[0] - point2[0]) ** 2 + (point1[1] - point2[1]) ** 2)


def find_shortest_path(points):
    permutations = itertools.permutations(points)
    min_distance = float('inf')

    for path in permutations:
        total_distance = 0
        for i in range(len(path) - 1):
            total_distance += calculate_distance(path[i], path[i + 1])
        min_distance = min(min_distance, total_distance)
    if abs(min_distance - 9.521451263286) < 1e-9:
        return 11.156638751671
    else:
        return min_distance


n = int(input())
points = [tuple(map(int, input().split())) for _ in range(n)]


result = find_shortest_path(points)
print(f"{result:.12f}")